︠9bd4b256-9941-441d-a780-23ab38bdbcdbi︠
%html
<h1>Illustration zur &Uuml;bung 3 des Moduls 2.03&nbsp; (Grundlagen Statistik)</h1>
<p>Prof. Christian G&ouml;bel, Hochschule der Bundesagentur f&uuml;r Arbeit</p>

︡50ec5751-c817-4cc5-93aa-906f6927b6ff︡{"html": "<h1>Illustration zur &Uuml;bung 3 des Moduls 2.03&nbsp; (Grundlagen Statistik)</h1>\n<p>Prof. Christian G&ouml;bel, Hochschule der Bundesagentur f&uuml;r Arbeit</p>"}︡
︠3b7b444d-fd95-4534-99b9-9089a7ccdf45ai︠
%hide
%auto
thickN = 3      #line thickness
fontN = 14

import matplotlib
matplotlib.rcParams.update({'lines.linewidth':thickN })
matplotlib.rcParams.update({'axes.linewidth':thickN })
matplotlib.rcParams.update({'axes.labelsize':fontN})  
matplotlib.rcParams.update({'xtick.major.size':6})      #length of ticks
matplotlib.rcParams.update({'lines.markeredgewidth':2}) #width of ticks
matplotlib.rcParams.update({'lines.markersize':6})      #size of ticks
matplotlib.rcParams.update({'patch.linewidth':thickN }) #linewidth of histogram
matplotlib.rcParams.update({'font.size': fontN})        #fontsize of histogram

NV01 = RealDistribution('gaussian',1)  #N(0,1)  mean=0 std dev = 1
NV02 = RealDistribution('gaussian',2)  #N(0,1)  mean=0 std dev = 2
GV02 = RealDistribution('uniform', [-2,2])
︡7feae198-b5c2-44d9-91b9-c1a1c67bf5e8︡︡
︠e6a3ab8b-b2f5-4c89-aa2d-9b175829570ai︠
%html
<h3>Illustration: Gesetz der gro&szlig;en Zahlen</h3>
<p>Angenommen wir h&auml;tten ein diskrete Zufallsvariable X mit der folgenden Wahrscheinlickeitsfunktion:</p>
<p>f(x) = P(x) = 0.3 f&uuml;r x=0</p>
<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; = 0.4 f&uuml;r x=1</p>
<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; = 0.3 f&uuml;r x=2</p>
<p>Der Erwartungswert von X betr&auml;gt 1.</p>
<p>Stellt man diese Wahrscheinlickheitsfunktion graphisch dar, so erh&auml;lt man:</p>

︡8514e9eb-8e17-4854-9910-ffca43c42b0a︡{"html": "<h3>Illustration: Gesetz der gro&szlig;en Zahlen</h3>\n<p>Angenommen wir h&auml;tten ein diskrete Zufallsvariable X mit der folgenden Wahrscheinlickeitsfunktion:</p>\n<p>f(x) = P(x) = 0.3 f&uuml;r x=0</p>\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; = 0.4 f&uuml;r x=1</p>\n<p>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; = 0.3 f&uuml;r x=2</p>\n<p>Der Erwartungswert von X betr&auml;gt 1.</p>\n<p>Stellt man diese Wahrscheinlickheitsfunktion graphisch dar, so erh&auml;lt man:</p>"}︡
︠f9c53d03-b4fd-4ece-ad23-6e7eca56d89dai︠
%hide
%auto
P = [0.3, 0.4, 0.3]            # P(0)=0.3  P(1)=0.4  P(2)=0.3
GDiscr343 = GeneralDiscreteDistribution(P)
def plot_discr(P):
    thickN = 3    #line thickness
    fontN  = "14"   #font size
    discr343 = [(_,P[_]) for _ in range(len(P))]                # Prepare distribution for visualization
    P4 = scatter_plot(discr343, markersize=100, facecolor='blue', xmin=-0.1, xmax=(len(P)-0.9), 
    ymin=0, ymax=1, fontsize=fontN  )
    counter = 0
    for expr in P:
        P4 += line([(counter,0),(counter,expr)], linestyle="--",color='black',thickness=thickN+1)
        counter = counter + 1
    P4.axes_width(2)
    P4.axes_labels(['x','P(x)'])
    P4.show(ticks=[[0,1,2,3],[0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0]],fontsize=fontN)
plot_discr(P)
︡75501315-87e8-4bb6-be52-e31ae1d1ac53︡︡
︠ff70e689-3307-4930-86d5-3c25366a2186i︠
%html
<p>Nun ziehen wir eine Stichprobe der Gr&ouml;&szlig;e 30 aus dieser Verteilung und berechnen Mittelwert und Standardfehler f&uuml;r die Stichprobe.<br />Die Stichprobe l&auml;sst sich nat&uuml;rlich auch graphisch Darstellen. Im oberen Bild werden die Auspr&auml;gungen dargestellt, da die Stichprobe 30 Auspr&auml;gungen enth&auml;lt gibt es insgesamt 30 Punkte.</p>
<p>Im n&auml;chsten Schritte beobachten wir wie sich der Mittelwert mit steigender Stichprobengr&ouml;&szlig;e entwickelt. F&uuml;r jede Stichprobengr&ouml;&szlig;e wurde der Mittelwert nur f&uuml;r die bisher gezogenen Auspr&auml;gungen berechnet.</p>
<p>Beispiel:<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 2 berechnet sich aus den ersten 2 Auspr&auml;gungen der Stichprobe.<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 3 berechnet sich aus den ersten 3 Auspr&auml;gungen der Stichprobe.<br />....<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 30 berechnet sich aus der gesamten Stichprobe (30 Auspr&auml;gungen der Stichprobe).</p>
<p>H&auml;ufig kann man beobachten, dass sich der Mittelwert bereits bei einer Stichprobengr&ouml;&szlig;e von 30 dem Erwartungswert ann&auml;hert.</p>

︡47ec7adf-fe5e-4fbb-9092-43b6dbca40b5︡{"html": "<p>Nun ziehen wir eine Stichprobe der Gr&ouml;&szlig;e 30 aus dieser Verteilung und berechnen Mittelwert und Standardfehler f&uuml;r die Stichprobe.<br />Die Stichprobe l&auml;sst sich nat&uuml;rlich auch graphisch Darstellen. Im oberen Bild werden die Auspr&auml;gungen dargestellt, da die Stichprobe 30 Auspr&auml;gungen enth&auml;lt gibt es insgesamt 30 Punkte.</p>\n<p>Im n&auml;chsten Schritte beobachten wir wie sich der Mittelwert mit steigender Stichprobengr&ouml;&szlig;e entwickelt. F&uuml;r jede Stichprobengr&ouml;&szlig;e wurde der Mittelwert nur f&uuml;r die bisher gezogenen Auspr&auml;gungen berechnet.</p>\n<p>Beispiel:<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 2 berechnet sich aus den ersten 2 Auspr&auml;gungen der Stichprobe.<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 3 berechnet sich aus den ersten 3 Auspr&auml;gungen der Stichprobe.<br />....<br />Der Mittelwert f&uuml;r die Stichprobengr&ouml;&szlig;e 30 berechnet sich aus der gesamten Stichprobe (30 Auspr&auml;gungen der Stichprobe).</p>\n<p>H&auml;ufig kann man beobachten, dass sich der Mittelwert bereits bei einer Stichprobengr&ouml;&szlig;e von 30 dem Erwartungswert ann&auml;hert.</p>"}︡
︠854bbf7d-1251-44cc-b0e9-938ee67c31e3i︠
%hide
N_draws = 30
r_discr343 = [GDiscr343.get_random_element() for _ in range(N_draws)]        # draw random variables from discret distribution
Mittel =  N(mean(r_discr343))
Stand =  N(std(r_discr343))

print '<html>'
print '<b><font size=+3>Stichprobe: %s </font></b><br>' %r_discr343
print '<b><font size=+3>Mittelwert: %s </font></b><br>' %Mittel
print '<b><font size=+3>Standardfehler: %s </font></b><br>' %Stand
print '</html>'

#scatter plot of the raw-data
sample = [(_+1,r_discr343[_]) for _ in range(len(r_discr343))]             # Prepare sample for visualization
P4 = scatter_plot(sample, markersize=80, fontsize=fontN, facecolor='blue', xmin=-0.1, xmax=(len(sample)))
P4.axes_width(2)
P4.axes_labels(['Stichprobengroesse','Auspraegung'])
P4.show(ticks=[None,[1,2]],fontsize=fontN)

#compute mean for raw-data - update mean for each new number
Sum_sample = r_discr343[:]    #copy of raw-data
Mean_sample = []
counter = 0
for expr in r_discr343:
    if counter == 0:
        Sum_sample[counter] = Sum_sample[counter]
    if counter >  0:
        Sum_sample[counter] = Sum_sample[counter]+Sum_sample[counter-1]
    Mean_sample.append(N(Sum_sample[counter]/(counter+1)))
    counter = counter + 1
html('<b><font size=+3>Aktualisierte Mittelwerte: %s </font></b><br>' %Mean_sample )

sample = [(_+1,Mean_sample[_]) for _ in range(len(Mean_sample))]             # Prepare sample for visualization
P5 = scatter_plot(sample, markersize=60, fontsize=fontN, facecolor='blue', xmin=-0.1, xmax=(len(sample)), ymin=0, ymax=2)
P5.axes_width(2)
P5.axes_labels(['Stichprobengroesse','Mittelwert'])
P5.show(ticks=[None,[1,2,3]],fontsize=fontN )
︡fadd007f-85bc-4e1d-9ba2-856c26e592cf︡{"html": "\n<b><font size=+3>Stichprobe: [0, 0, 1, 2, 0, 2, 0, 2, 2, 1, 1, 0, 1, 0, 1, 1, 0, 2, 1, 0, 2, 2, 0, 1, 2, 0, 2, 0, 0, 1] </font></b><br>\n<b><font size=+3>Mittelwert: 0.900000000000000 </font></b><br>\n<b><font size=+3>Standardfehler: 0.844862771962569 </font></b><br>\n"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡{"html": "<font color='black'><b><font size=+3>Aktualisierte Mittelwerte: [0.000000000000000, 0.000000000000000, 0.333333333333333, 0.750000000000000, 0.600000000000000, 0.833333333333333, 0.714285714285714, 0.875000000000000, 1.00000000000000, 1.00000000000000, 1.00000000000000, 0.916666666666667, 0.923076923076923, 0.857142857142857, 0.866666666666667, 0.875000000000000, 0.823529411764706, 0.888888888888889, 0.894736842105263, 0.850000000000000, 0.904761904761905, 0.954545454545455, 0.913043478260870, 0.916666666666667, 0.960000000000000, 0.923076923076923, 0.962962962962963, 0.928571428571429, 0.896551724137931, 0.900000000000000] </font></b><br></font>"}︡{"html": "<font color='black'><img src='cell://sage1.png'></font>"}︡
︠f491bb66-5b8f-4e66-ab60-b56341364786i︠
%html
<p>Was passiert eigentlich f&uuml;r sehr gro&szlig;e Stichproben? Das Gesetz der gro&szlig;en Zahlen sagt uns ja, dass f&uuml;r unendlich gro&szlig;e Stichproben der Mittelwert dem Erwartungwert enspricht.</p>
<p>Hier eine Illustration:</p>

︡93a95621-fc65-4d73-bae0-75fe326c37f8︡{"html": "<p>Was passiert eigentlich f&uuml;r sehr gro&szlig;e Stichproben? Das Gesetz der gro&szlig;en Zahlen sagt uns ja, dass f&uuml;r unendlich gro&szlig;e Stichproben der Mittelwert dem Erwartungwert enspricht.</p>\n<p>Hier eine Illustration:</p>"}︡
︠a845d67a-a9fe-44cf-9b78-72e099306956ai︠
%hide
%auto
def LLN_mean_E(Distr,_N_draws):
    r_discr343 = [GDiscr343.get_random_element() for _ in range(_N_draws)]        # draw random variables from discret distribution
    #compute mean for raw-data - update mean for each new number
    counter = 0
    Sum_sample = r_discr343[:]    #copy of raw-data
    Mean_sample = []
    for expr in r_discr343:
        if counter == 0:
            Sum_sample[counter] = Sum_sample[counter]
        if counter >= 1:
            Sum_sample[counter] = Sum_sample[counter]+Sum_sample[counter-1]
        Mean_sample.append(N(Sum_sample[counter]/(counter+1)))
        counter = counter + 1
    sample = [(_+1,Mean_sample[_]) for _ in range(len(Mean_sample))]             # Prepare sample for visualization
    P4 = scatter_plot(sample, markersize=30, fontsize=fontN, facecolor='blue', xmin=-0.1, xmax=(len(sample)), ymin=0,ymax=2)
    P4.axes_width(2)
    P4.axes_labels(['Stichprobengroesse','Mittelwert'])
    P4.show(ticks=[None,[1,2]],fontsize=fontN)
    
@interact
def _(_N_draws = slider(10,10000,5,default=10,label="Stichprobengröße:")):
    LLN_mean_E(GDiscr343,_N_draws)
︡1a7da03c-4954-4392-a343-733a68b10706︡︡
︠05ac7d36-611a-4b10-90ff-7a5f1855f78ai︠
%html
<p>Das Gesetz der gro&szlig;en Zahlen (im weiteren Sinn) beruht darauf, dass in sehr gro&szlig;en (unendlich) gro&szlig;en Stichproben die Wahrscheinlichkeitsverteilung der Grundgesamtheit repliziert wird.</p>
<p>Intuitiv macht das auch Sinn, den die Wahrscheinlichkeitsverteilung gibt ja gerade an, wie h&auml;ufig bestimmte Werte vorkommen.</p>
<p>Zur Illustration verwenden wir eine Normalverteilung mit Erwartungwert 0 und einer Standardabweichung von 2. NV(0,2).</p>
<p>Wir Ziehen aus der Verteilung und lasen uns f&uuml;r die Stichprobe das Histogram ausgeben.</p>

︡6549ad9c-e03d-4eb6-83ec-f2f3f1ffe09f︡{"html": "<p>Das Gesetz der gro&szlig;en Zahlen (im weiteren Sinn) beruht darauf, dass in sehr gro&szlig;en (unendlich) gro&szlig;en Stichproben die Wahrscheinlichkeitsverteilung der Grundgesamtheit repliziert wird.</p>\n<p>Intuitiv macht das auch Sinn, den die Wahrscheinlichkeitsverteilung gibt ja gerade an, wie h&auml;ufig bestimmte Werte vorkommen.</p>\n<p>Zur Illustration verwenden wir eine Normalverteilung mit Erwartungwert 0 und einer Standardabweichung von 2. NV(0,2).</p>\n<p>Wir Ziehen aus der Verteilung und lasen uns f&uuml;r die Stichprobe das Histogram ausgeben.</p>"}︡
︠9d8f1869-05e0-427e-a1cd-51e4950d2a07ai︠
%hide
%auto
import matplotlib
from pylab import figure, show
Xmin=-15
Xmax=15
def Histo_graph(Distr,_N_draws,WS_bool):
    if WS_bool:
        p_distr = Distr.plot((x,Xmin,Xmax),fill='axis',ymax='0.12', fillcolor='blue',fillalpha='0.1',thickness=thickN,fontsize=fontN)   #density of NV(0,1)
        p_distr.axes_width(2)
        p_distr.axes_labels(['x','f(x)'])
        p_distr.show(fontsize=fontN)
    startseed = random()*1000000      #save a random seed
    Distr.set_seed(startseed)         #set seed to inital seed
    randomdraws1 = [Distr.get_random_element() for _ in range(_N_draws)]
    #print randomdraws1
    Distr.set_seed(startseed)    #set seed to initial seed
    randomdraws1scatter = [(Distr.get_random_element(),0) for _ in range(_N_draws)]
    p_scatter = scatter_plot(randomdraws1scatter, xmin=Xmin, xmax=Xmax,fontsize=fontN)
    #p_scatter.show()
    import matplotlib.pyplot as plt
    def histo(samplelist):
        fig = figure(facecolor='white')
        ax = fig.add_subplot(111, frame_on=True)    #Make sure that the frame is drawn correctly
        n, bins, patches = plt.hist(samplelist, normed=True, range=(Xmin,Xmax), bins=25, hold=False)
        plt.savefig('test.png')
    histo(randomdraws1)
    
@interact
def _(WS_bool=checkbox(True,"WS-verteilung anzeigen:"),
_N_draws=slider(10,10000,5,default=10,label="Stichprobengröße:"),
Ziehung=['Neue Ziehung']):
    Histo_graph(NV02,_N_draws,WS_bool)
︡981f0a1d-3fc4-46f3-adfc-8972d4d30821︡︡
︠5fcfe2d6-0ce9-4661-8bc0-12fc4f70b3fei︠
%html
<h3>Illustration: Mittelwerte sind zuf&auml;llig</h3>
<p>Wenn Wir den Mittelwert eine (Zufalls-)-Stichprobe berechnen, dann h&auml;ngt der Mittelwert von den zuf&auml;llig gezogenen Auspr&auml;gungen ab.</p>
<p>Der Mittelwert ist deshlab selbst zuf&auml;llig und bei jeder neuen Ziehung hat der Mittelwert einen anderen Betrag.</p>
<p>Illustration: Wir ziehen eine Stichprobe aus einer Standardnormalverteilung (Erwartungwert 0, Standardabweichung 1)&nbsp; NV(0,1) und</p>
<p>berechnen den Mittelwert.</p>
<p>Frage: Was k&ouml;nnen wir beobachten wenn wir die Stichprobengr&ouml;&szlig;e erh&ouml;hen?</p>

︡85ec6b6e-7967-4b0b-a853-ebdc9c10ab12︡{"html": "<h3>Illustration: Mittelwerte sind zuf&auml;llig</h3>\n<p>Wenn Wir den Mittelwert eine (Zufalls-)-Stichprobe berechnen, dann h&auml;ngt der Mittelwert von den zuf&auml;llig gezogenen Auspr&auml;gungen ab.</p>\n<p>Der Mittelwert ist deshlab selbst zuf&auml;llig und bei jeder neuen Ziehung hat der Mittelwert einen anderen Betrag.</p>\n<p>Illustration: Wir ziehen eine Stichprobe aus einer Standardnormalverteilung (Erwartungwert 0, Standardabweichung 1)&nbsp; NV(0,1) und</p>\n<p>berechnen den Mittelwert.</p>\n<p>Frage: Was k&ouml;nnen wir beobachten wenn wir die Stichprobengr&ouml;&szlig;e erh&ouml;hen?</p>"}︡
︠ee773e6d-7cc1-446b-8d1c-3fd9dbeb54baai︠
%hide
%auto
def Mean_draws(Distr,_N_draws,WS_bool):
    startseed = random()*1000000      #save a random seed
    Distr.set_seed(startseed)         #set seed to inital seed
    randomdraws1 = [Distr.get_random_element() for _ in range(_N_draws)]
    print "Mittelwert:"
    print mean(randomdraws1)
    if WS_bool:
        p = Distr.plot((x,-4,4),fill='axis',ymax='0.5', fillcolor='blue',fillalpha='0.1',thickness=thickN,fontsize=fontN)   #density of NV(0,1)
        p += line([(mean(randomdraws1),0.01),(mean(randomdraws1),-0.02)], linestyle="-",color='red',thickness=2)
        p += text("$\mu$",(mean(randomdraws1),-0.04), fontsize=16, color='red')
        p.axes_width(2)
        p.axes_labels(['x','f(x)'])
        p.show(fontsize=fontN)
    Distr.set_seed(startseed)    #set seed to initial seed
    randomdraws1scatter = [(Distr.get_random_element(),0) for _ in range(_N_draws)]
    P1 = scatter_plot(randomdraws1scatter, xmin=-4, xmax=4, ymin=-0.01, ymax=0.01, fontsize=fontN)
    P1.axes_width(2)
    P1.axes_labels(['x',''])
    P1.show(ticks=[None,[]],fontsize=fontN)

@interact
def _(WS_bool=checkbox(True,"WS-verteilung anzeigen:"),
_N_draws=slider(2,500,2,default=2,label="Stichprobengröße:"),
Ziehung=['Neue Ziehung']):
    Mean_draws(NV01,_N_draws,WS_bool)
︡9aeee4c8-bb9e-4cc9-bbb7-52627124f11d︡︡
︠b74ca506-f357-4185-91c4-0a92d22cbb78i︠
%html
<h3>Verteilung von Mittelwerten:</h3>
<p>In sehr gro&szlig;en Stichproben sind Mittelwerte ann&auml;hernd Normalverteilt (Dies folgt aus dem zentraler Grenzwertsatz).</p>
<p>Wir k&ouml;nnen das Gesetz der Gro&szlig;en Zahlen nutzen um die Form der Verteilung der Mittelwerte "sichtbar" zu machen.</p>
<p>Vorgehensweise (beispielhaft):<br />Schritt 1: Wir ziehen eine Zufallsstichprobe z.B. der Gr&ouml;&szlig;e 30 und berechnen deren Mittelwert.<br />Schritt 2: Wir wiederholen Schritt 1 sehr h&auml;ufig und generieren so sehr viele Mittelwerte (alle Mittelwert f&uuml;r die gleiche Stichprobengr&ouml;&szlig;e und aus der gleichen Grundgesamtheit).<br />Schritt 3: Ein Histogramm kann f&uuml;r die Veranschaulichung der Verteilung der Mittelwerte genutzt werden.</p>
<p>Dieses "Experiment" k&ouml;nnen wir f&uuml;r unterschiedliche Stichprobengr&ouml;&szlig;en und Verteilungen der Grundgesamtheit durchf&uuml;hren.</p>
<p>Folgende Beobachtungen lassen sich dabei machen:</p>
<p>1. Wenn die Stichprobe gro&szlig; genug ist, dann ist der Mittelwert immer ann&auml;hernd normalverteilt; dies gilt unabh&auml;ngig von der Verteilung der Grundgesamtheit (aus der wir die Stichproben ziehen).</p>
<p>2. Die Varianz der Verteilung der Mittelwerte nimmt mit der Stichprobengr&ouml;&szlig;e ab.</p>
<p>3. Ist die Grundgesamtheit bereits selbst (zumindest ann&auml;hernd) normalverteilt, dann ben&ouml;tigen wir nur relativ kleine Stichproben, damit der Mittelwert normalverteilt ist.</p>
<p>4. Ist die Verteilung der Grundgesamtheit selbst "sehr weit" von einer normalverteilung entfernt, dann ben&ouml;tigt man tats&auml;chlich sehr gro&szlig;e Stichproben, damit der Mittelwert der Stichproben sich einer Normalverteilung ann&auml;hert.</p>

︡2fcd8068-106f-499a-a184-ea7220e56eaa︡{"html": "<h3>Verteilung von Mittelwerten:</h3>\n<p>In sehr gro&szlig;en Stichproben sind Mittelwerte ann&auml;hernd Normalverteilt (Dies folgt aus dem zentraler Grenzwertsatz).</p>\n<p>Wir k&ouml;nnen das Gesetz der Gro&szlig;en Zahlen nutzen um die Form der Verteilung der Mittelwerte \"sichtbar\" zu machen.</p>\n<p>Vorgehensweise (beispielhaft):<br />Schritt 1: Wir ziehen eine Zufallsstichprobe z.B. der Gr&ouml;&szlig;e 30 und berechnen deren Mittelwert.<br />Schritt 2: Wir wiederholen Schritt 1 sehr h&auml;ufig und generieren so sehr viele Mittelwerte (alle Mittelwert f&uuml;r die gleiche Stichprobengr&ouml;&szlig;e und aus der gleichen Grundgesamtheit).<br />Schritt 3: Ein Histogramm kann f&uuml;r die Veranschaulichung der Verteilung der Mittelwerte genutzt werden.</p>\n<p>Dieses \"Experiment\" k&ouml;nnen wir f&uuml;r unterschiedliche Stichprobengr&ouml;&szlig;en und Verteilungen der Grundgesamtheit durchf&uuml;hren.</p>\n<p>Folgende Beobachtungen lassen sich dabei machen:</p>\n<p>1. Wenn die Stichprobe gro&szlig; genug ist, dann ist der Mittelwert immer ann&auml;hernd normalverteilt; dies gilt unabh&auml;ngig von der Verteilung der Grundgesamtheit (aus der wir die Stichproben ziehen).</p>\n<p>2. Die Varianz der Verteilung der Mittelwerte nimmt mit der Stichprobengr&ouml;&szlig;e ab.</p>\n<p>3. Ist die Grundgesamtheit bereits selbst (zumindest ann&auml;hernd) normalverteilt, dann ben&ouml;tigen wir nur relativ kleine Stichproben, damit der Mittelwert normalverteilt ist.</p>\n<p>4. Ist die Verteilung der Grundgesamtheit selbst \"sehr weit\" von einer normalverteilung entfernt, dann ben&ouml;tigt man tats&auml;chlich sehr gro&szlig;e Stichproben, damit der Mittelwert der Stichproben sich einer Normalverteilung ann&auml;hert.</p>"}︡
︠4467814d-a3e0-446a-a758-afb619e8c4f1ai︠
%hide
%auto 
import matplotlib
import matplotlib.pyplot as plt
from pylab import figure, show

NV01 = RealDistribution('gaussian',1)  #N(0,1)  mean=0 std dev = 1
NV02 = RealDistribution('gaussian',4)  #N(0,4)  mean=0 std dev = 4
GV02 = RealDistribution('uniform', [0,2])
P343 = [0.3, 0.4, 0.3]            # P(0)=0.3  P(1)=0.4  P(2)=0.3
DV343 = GeneralDiscreteDistribution(P343)
P55  = [0.5, 0.5]                 # P(0)=0.5  P(1)=0.5 
DV55  = GeneralDiscreteDistribution(P55)
P19  = [0.1, 0.9]                 # P(0)=0.1  P(1)=0.9 
DV19  = GeneralDiscreteDistribution(P19)

def plot_discr(P):
    discrd = [(_,P[_]) for _ in range(len(P))]                # Prepare distribution for visualization
    P4 = scatter_plot(discrd, markersize=100, facecolor='blue', xmin=-0.1, xmax=(len(P)-0.9), 
    ymin=0, ymax=1, fontsize=fontN  )
    counter = 0
    for expr in P:
        P4 += line([(counter,0),(counter,expr)], linestyle="--",color='black',thickness=thickN+1)
        counter = counter + 1
    P4.axes_width(2)
    P4.axes_labels(['x','P(x)'])
    P4.show(fontsize=fontN)

def plot_cont(Distr,Xmin,Xmax):
    p = Distr.plot((x,Xmin,Xmax),fill='axis', fillcolor='blue',fillalpha='0.1',thickness=thickN,fontsize=fontN)
    p.axes_width(2)
    p.axes_labels(['x','f(x)'])
    p.show(fontsize=fontN,aspect_ratio='automatic',ymax=1)

def histo(samplelist):
    fig = figure(facecolor='white')
    ax = fig.add_subplot(111, frame_on=True)    #Make sure that the frame is drawn correctly
    n, bins, patches = plt.hist(samplelist, normed=True, bins=25, hold=False)
    plt.savefig('test.png')

def meandraws(Distr,N_draws,N_mean_draws):
    means = []
    tempdraws = []
    for count in range(N_mean_draws):
        tempdraws = [Distr.get_random_element() for _ in range(N_draws)]
        means.append(mean(tempdraws))
    histo(means)

@interact
def distri_mean_(
WS_bool=checkbox(True,"WS-verteilung anzeigen:"),
distribution = selector(['NV(0,1)', 'NV(0,16)', 'GV[0;2]', 'DV55', 'DV343', 'DV19'], nrows=1, label="WS-Verteilung:"),
repets = slider([5..10000],default=20,label="Anzahl der Wiederholungen:"),
draws  = slider([10..10000],default=10,label="Stichprobengroesse:")
):
    if   distribution == 'NV(0,1)':
        distr=NV01
        if WS_bool == True: plot_cont(distr,-4,4)
    elif distribution == 'NV(0,16)':
        distr=NV02
        if WS_bool == True: plot_cont(distr,-10,10)
    elif distribution == 'GV[0;2]':
        distr=GV02
        if WS_bool == True: plot_cont(distr,-1,3)
    elif distribution == 'DV55':
        distr=DV55
        if WS_bool == True: plot_discr(P55)
    elif distribution == 'DV343':
        distr=DV343
        if WS_bool == True: plot_discr(P343)
    elif distribution == 'DV19':
        distr=DV19
        if WS_bool == True: plot_discr(P19)
    #print distr
    meandraws(distr,draws,repets)
︡2f61557d-84a8-47b4-9d86-20f4b073a3c6︡︡
